{ *************************************************************************** }
{                                                                             }
{ WindowsXP-like Character Map                                               }
{                                                                             }
{ Copyright (c) 2004 Sergey Mishin <mishinmail@mail.ru>                       }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }
unit uMain;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QGrids, QExtCtrls, QComCtrls, uXPAPI, QClipbrd, TypInfo;

type
  TfrmMain = class(TForm)
    Button1: TButton;
    edtBuffer: TEdit;
    StringGrid: TStringGrid;
    cboFonts: TComboBox;
    FontDialog1: TFontDialog;
    Button4: TButton;
    Label2: TLabel;
    Button5: TButton;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    Panel1: TPanel;
    btnFind: TButton;
    cboCharsets: TComboBox;
    Label5: TLabel;
    edtSymbol: TEdit;
    Label7: TLabel;
    edtCode: TEdit;
    lblGoto: TLabel;
    pnlSymbol: TPanel;
    Image1: TImage;
    lblBigSymbol: TLabel;
    pnlBottom: TPanel;
    lblSymbolCode: TLabel;
    Label9: TLabel;
    procedure StringGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure cboFontsChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure edtCodeReturnPressed(Sender: TObject);
    procedure edtSymbolChange(Sender: TObject);
    procedure cboCharsetsChange(Sender: TObject);
    procedure lblBigSymbolClick(Sender: TObject);
    procedure lblBigSymbolMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.xfm}
procedure FindByCode(Code: integer);
var CanSelect:boolean;
    Col: integer;
    Row: integer;
begin
        if Code> 20 then begin
             Row:=Code div 20;
             Col:=Abs(Code - Row*20);
        end
        else  begin
             Row:=0;
             Col:=Code;
        end;
        CanSelect:=True;
        frmMain.StringGridSelectCell(frmMain.StringGrid,Col,Row,CanSelect);
end;


procedure TfrmMain.StringGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
    lblSymbolCode.Caption:=' U+'+IntToStr(ARow*20+ACol)+' Symbol "'+
                                StringGrid.Cells[ACol,ARow]+'"';
    lblBigSymbol.Hint:=lblSymbolCode.Caption;
     lblBigSymbol.Visible:=True;
     lblBigSymbol.Caption:=StringGrid.Cells[ACol,ARow];

     pnlSymbol.Top:=StringGrid.CellRect(ACol,ARow).Top+35;
     pnlSymbol.Left:=StringGrid.CellRect(ACol,ARow).Left;


     pnlSymbol.Visible:=True;

end;

procedure TfrmMain.cboFontsChange(Sender: TObject);

begin
  FontDialog1.Font.Name:=cboFonts.Text;
  StringGrid.Font.Assign(FontDialog1.Font);
  edtBuffer.Font.Name:=cboFonts.Text;
  edtSymbol.Font.Name:=cboFonts.Text;
  pnlSymbol.Visible:=False;
  
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
     FontDialog1.Font.Name:=cboFonts.Text;
     if FontDialog1.Execute then StringGrid.Font:=FontDialog1.Font;
end;

procedure TfrmMain.btnFindClick(Sender: TObject);
var i : integer;
    j: integer;
    k: integer;
    CanSelect:boolean;
begin
     
     if btnFind.Caption ='Search' then begin
        k:=0;
        while k < 256 do begin
            for  i:=0  to 100 do begin
               for  j:=0  to 20 do begin
                    if edtSymbol.Text=StringGrid.Cells[j,i] then begin
                       CanSelect:=True;
                       StringGridSelectCell(StringGrid,j,i,CanSelect);
                       btnFind.Caption :='Reset';
                       exit;
                    end
                    else Inc(k);
               end;
            end;
        end;
     end
     else begin
         //FindByCode(0);
         pnlSymbol.Visible:=False;
         btnFind.Caption:='Search';
         btnFind.Enabled:=False;
         edtCode.Text:='';
         edtSymbol.Text:='';
     end;

end;

procedure TfrmMain.Button5Click(Sender: TObject);
begin
        ShowMessage('Help system not implemented yet...');
end;

procedure TfrmMain.CheckBox1Click(Sender: TObject);
begin
     if CheckBox1.Checked then begin
        frmMain.Height:=frmMain.Height+Panel1.Height;
        pnlBottom.Align:=alBottom;
        Panel1.Visible:=True;
     end
     else begin
        Panel1.Visible:=False;
        frmMain.Height:=frmMain.Height-Panel1.Height;
     end;

end;

procedure TfrmMain.FormCreate(Sender: TObject);
var i : integer;
    j: integer;
    k: integer;
    T: PTypeInfo;
    D: PTypeData;
begin
    Panel1.Visible:=False;
    frmMain.Height:=frmMain.Height-Panel1.Height;
    lblBigSymbol.Caption:='';
    cboFonts.ItemIndex:=0;
    edtBuffer.Font.Name:=cboFonts.Text;
    edtSymbol.Font.Name:=cboFonts.Text;

    XPAPI.setdefaultcursor;

    for i := 1 to Screen.Fonts.Count do
     cboFonts.Items.Add(Screen.Fonts.Strings[i - 1]);
     cboFonts.ItemIndex := 0;
      k:=0;
      while k < 256 do begin
          for  i:=0  to 100 do begin
             for  j:=0  to 20 do begin
                  StringGrid.Cells[j,i]:=Chr(k);
                  Inc(k);
             end;
          end;
      end;

     T:=TypeInfo(TFontCharset);
     D:=GetTypeData(T);
      for i:=0 to D.MaxValue do
         cboCharsets.Items.Add(GetEnumName(T,i));
         cboCharsets.ItemIndex:=0;

end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
    if edtBuffer.SelLength<>0 then edtBuffer.CopyToClipboard
    else Clipboard.AsText:=edtBuffer.Text;

end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
     edtBuffer.Text:=edtBuffer.Text+lblBigSymbol.Caption;
end;

procedure TfrmMain.edtCodeReturnPressed(Sender: TObject);
begin
     FindByCode(StrToInt(edtCode.text));
     btnFind.Caption:='Reset';
     btnFind.Enabled:=True;
end;

procedure TfrmMain.edtSymbolChange(Sender: TObject);
begin
    if edtSymbol.Text<>'' then begin
        btnFind.Enabled:=True;
        lblGoto.Enabled:=False;
        edtCode.Enabled:=False;
    end
    else begin
        btnFind.Enabled:=False;
        lblGoto.Enabled:=True;
        edtCode.Enabled:=True;
    end;
end;

procedure TfrmMain.cboCharsetsChange(Sender: TObject);
begin
    FontDialog1.Font.CharSet:=TFontCharset(cboCharsets.ItemIndex);
    StringGrid.Font.Assign(FontDialog1.Font);
    edtBuffer.Font.Name:=cboFonts.Text;
    edtSymbol.Font.Name:=cboFonts.Text;
    pnlSymbol.Visible:=False;
end;

procedure TfrmMain.lblBigSymbolClick(Sender: TObject);
begin
     edtBuffer.Text:=edtBuffer.Text+lblBigSymbol.Caption;
end;

procedure TfrmMain.lblBigSymbolMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     pnlSymbol.Visible:=False;
end;

end.
